> ## Documentation Index > Fetch the complete documentation index at: https://support.tulip.co/llms.txt > Use this file to discover all available pages before exploring further. # /api/users/v1/user-groups > Lists all user groups. ## OpenAPI ````json GET /api/users/v1/user-groups { "openapi": "3.0.3", "info": { "title": "Tulip API", "version": "v1" }, "tags": [ { "name": "machines", "description": "An API for managing machines and their types" }, { "name": "stations", "description": "An API for managing and updating stations." }, { "name": "users", "description": "An API for managing users and their roles/permissions." } ], "paths": { "/api/users/v1/user-groups": { "get": { "operationId": "listUserGroups", "description": "Lists all user groups.", "tags": [ "users" ], "x-tulip-visibility": "public", "parameters": [ { "name": "limit", "description": "The number of items to return in the response.", "in": "query", "required": "false", "schema": { "$ref": "#/components/schemas/PaginationParamLimit" } }, { "name": "filter", "description": "Filters the result using OData 4.01 syntax. Supports filtering on the `id` field.\nOnly supports the `eq` and `or` operators.\n", "in": "query", "required": "false", "schema": { "type": "string" } }, { "name": "offset", "description": "The number of items to skip before collecting the result.", "in": "query", "required": "false", "schema": { "$ref": "#/components/schemas/PaginationParamOffset" } }, { "name": "search", "description": "The string to match when searching for user groups.", "in": "query", "required": "false", "schema": { "type": "string" } }, { "name": "archived", "description": "When set to `false` (the default), only un-archived user groups are returned.\nWhen set to `true`, only archived user groups are returned.\n", "in": "query", "required": "false", "schema": { "type": "boolean" } } ], "responses": { "200": { "description": "A list of available user groups\n", "content": { "application/json": { "schema": { "allOf": [ { "type": "object", "properties": { "items": { "type": "array", "items": { "$ref": "#/components/schemas/UserGroup" } } } }, { "$ref": "#/components/schemas/PaginatedResponse" } ] } } } }, "400": { "description": "An error occurred. The Tulip error codes `generic.customerIdRequired`, `generic.workspaceIdRequired`, `generic.invalidParams`, `http.invalidBodyJson`, `http.invalidHeaders`, `http.multiValueHeader`, `generic.limitParamNonNegativeInt`, `generic.limitParamBounds`, `generic.offsetParamNonNegativeInt`, and `userGroups.invalidFilter` all use the 400 HTTP status code. See the documentation of the response content schema for details on these specific Tulip errors that could result in this status code.", "content": { "application/json": { "schema": { "oneOf": [ { "allOf": [ { "$ref": "#/components/schemas/ApiError" }, { "type": "object", "description": "The request was missing information about the Tulip customer context.\n\nThis error is not automatically retryable.", "properties": { "errorCode": { "enum": [ "generic.customerIdRequired" ] }, "retryable": { "enum": [ "false" ] } }, "required": [ "errorCode", "retryable" ] } ] }, { "allOf": [ { "$ref": "#/components/schemas/ApiError" }, { "type": "object", "description": "The request was missing information about the Tulip workspace context.\n\nThis error is not automatically retryable.", "properties": { "errorCode": { "enum": [ "generic.workspaceIdRequired" ] }, "retryable": { "enum": [ "false" ] } }, "required": [ "errorCode", "retryable" ] } ] }, { "allOf": [ { "$ref": "#/components/schemas/ApiError" }, { "type": "object", "description": "The request parameters were invalid.\n\nThis error is not automatically retryable.", "properties": { "errorCode": { "enum": [ "generic.invalidParams" ] }, "retryable": { "enum": [ "false" ] } }, "required": [ "errorCode", "retryable" ] } ] }, { "allOf": [ { "$ref": "#/components/schemas/ApiError" }, { "type": "object", "description": "The HTTP request body could not be decoded as JSON.\n\nThis error is not automatically retryable.", "properties": { "errorCode": { "enum": [ "http.invalidBodyJson" ] }, "retryable": { "enum": [ "false" ] } }, "required": [ "errorCode", "retryable" ] } ] }, { "allOf": [ { "$ref": "#/components/schemas/ApiError" }, { "type": "object", "description": "The HTTP request headers were invalid.\n\nThis error is not automatically retryable.", "properties": { "errorCode": { "enum": [ "http.invalidHeaders" ] }, "retryable": { "enum": [ "false" ] } }, "required": [ "errorCode", "retryable" ] } ] }, { "allOf": [ { "$ref": "#/components/schemas/ApiError" }, { "type": "object", "description": "An HTTP request header contained multiple values.\n\nThis error is not automatically retryable.", "properties": { "errorCode": { "enum": [ "http.multiValueHeader" ] }, "details": { "type": "object", "properties": { "headerName": { "description": "The name of the given HTTP header which had multiple values.\n", "type": "string" } }, "required": [ "headerName" ] }, "retryable": { "enum": [ "false" ] } }, "required": [ "errorCode", "retryable", "details" ] } ] }, { "allOf": [ { "$ref": "#/components/schemas/ApiError" }, { "type": "object", "description": "The limit parameter for this endpoint was not a non-negative integer.\n\nThis error is not automatically retryable.", "properties": { "errorCode": { "enum": [ "generic.limitParamNonNegativeInt" ] }, "retryable": { "enum": [ "false" ] } }, "required": [ "errorCode", "retryable" ] } ] }, { "allOf": [ { "$ref": "#/components/schemas/ApiError" }, { "type": "object", "description": "The limit parameter for this endpoint was out of bounds.\n\nThis error is not automatically retryable.", "properties": { "errorCode": { "enum": [ "generic.limitParamBounds" ] }, "details": { "type": "object", "properties": { "upperBound": { "description": "The maximum allowed value for the limit parameter.\n", "type": "integer" } }, "required": [ "upperBound" ] }, "retryable": { "enum": [ "false" ] } }, "required": [ "errorCode", "retryable", "details" ] } ] }, { "allOf": [ { "$ref": "#/components/schemas/ApiError" }, { "type": "object", "description": "The offset parameter for this endpoint was not a non-negative integer.\n\nThis error is not automatically retryable.", "properties": { "errorCode": { "enum": [ "generic.offsetParamNonNegativeInt" ] }, "retryable": { "enum": [ "false" ] } }, "required": [ "errorCode", "retryable" ] } ] }, { "allOf": [ { "$ref": "#/components/schemas/ApiError" }, { "type": "object", "description": "The user group filter provided is invalid.\n\nThis error is not automatically retryable.", "properties": { "errorCode": { "enum": [ "userGroups.invalidFilter" ] }, "retryable": { "enum": [ "false" ] } }, "required": [ "errorCode", "retryable" ] } ] } ] } } } }, "401": { "description": "The request was missing required authentication information.\n\nThis error is not automatically retryable.", "content": { "application/json": { "schema": { "allOf": [ { "$ref": "#/components/schemas/ApiError" }, { "type": "object", "description": "The request was missing required authentication information.\n\nThis error is not automatically retryable.", "properties": { "errorCode": { "enum": [ "generic.authRequired" ] }, "retryable": { "enum": [ "false" ] } }, "required": [ "errorCode", "retryable" ] } ] } } } }, "429": { "description": "Too many requests have been made to this endpoint in a short time period.\n\nThis error is not automatically retryable.", "content": { "application/json": { "schema": { "allOf": [ { "$ref": "#/components/schemas/ApiError" }, { "type": "object", "description": "Too many requests have been made to this endpoint in a short time period.\n\nThis error is not automatically retryable.", "properties": { "errorCode": { "enum": [ "http.endpointRateLimitExceeded" ] }, "details": { "type": "object", "properties": { "details": { "description": "Additional details about this endpoint's rate limits.\n", "type": "string" } } }, "retryable": { "enum": [ "false" ] } }, "required": [ "errorCode", "retryable", "details" ] } ] } } } }, "500": { "description": "An internal server error occurred. Please contact [support@tulip.co](mailto:support@tulip.co)\nif the error persists.\n\nThis error is not automatically retryable.", "content": { "application/json": { "schema": { "allOf": [ { "$ref": "#/components/schemas/ApiError" }, { "type": "object", "description": "An internal server error occurred. Please contact [support@tulip.co](mailto:support@tulip.co)\nif the error persists.\n\nThis error is not automatically retryable.", "properties": { "errorCode": { "enum": [ "generic.internal" ] }, "retryable": { "enum": [ "false" ] } }, "required": [ "errorCode", "retryable" ] } ] } } } } } } } }, "components": { "schemas": { "PaginationParamLimit": { "description": "The maximum number of items to return in the response. If this is set to 0, the endpoint will\nreturn a default number of items specific to the endpoint.\n", "type": "integer", "minimum": "0", "example": "1" }, "PaginationParamOffset": { "description": "The number of items to skip before collecting items for the response.\n", "type": "integer", "minimum": "0", "example": "0" }, "UserGroup": { "type": "object", "description": "Representation of a user group.\n", "properties": { "id": { "$ref": "#/components/schemas/UserGroupId" }, "name": { "type": "string", "description": "The user group's name." }, "description": { "type": "string", "description": "A human-readable description of the user group and what the group represents.\n" }, "avatar": { "type": "string", "description": "The storage key of the avatar which can be used to retrieve the avatar image's signed URL.\n" }, "assignedUsersCount": { "type": "number", "description": "The number of users assigned to the user group." }, "created": { "$ref": "#/components/schemas/StrictCreated" }, "lastModified": { "$ref": "#/components/schemas/LastModified" }, "archived": { "$ref": "#/components/schemas/Archived" } }, "required": [ "id", "name", "assignedUsersCount", "created", "lastModified" ], "example": { "id": "78M2aGebq5MjhKafN", "name": "Machine maintenance team", "description": "People responsible for the maintenance of the machines in the factory." } }, "PaginatedResponse": { "type": "object", "properties": { "count": { "description": "The total number of items that matched the list parameters.\n", "type": "number", "example": "10" }, "nextPage": { "description": "A URL at which the next page of results can be fetched.\n", "type": "string", "format": "url" }, "prevPage": { "description": "A URL at which the previous page of results can be fetched.\n", "type": "string", "format": "url" }, "items": { "type": "array", "items": {} }, "errors": { "type": "array", "description": "A list of errors per item that is omitted from the paginated response, if any.\n", "items": { "$ref": "#/components/schemas/PaginatedItemError" } } }, "required": [ "items" ] }, "ApiError": { "description": "An error response returned by a Tulip API.\n", "type": "object", "properties": { "errorCode": { "description": "A machine-readable code identifying the type of error.\n", "type": "string", "pattern": "^[a-zA-Z0-9.]$" }, "message": { "description": "A human-readable description of the error intended for debugging purposes only.\n\nThe exact content of this message is not stable.\n", "type": "string" }, "retryable": { "description": "Whether the request can be automatically retried by the client.\n", "type": "boolean" } }, "required": [ "errorCode", "retryable" ] }, "UserGroupId": { "allOf": [ { "$ref": "#/components/schemas/RandomId" }, { "description": "The unique identifier for a user group.\n" } ] }, "StrictCreated": { "allOf": [ { "$ref": "#/components/schemas/CRUDMetadata" }, { "description": "When and by whom a resource was created.\n", "required": [ "at", "by" ] } ] }, "LastModified": { "allOf": [ { "$ref": "#/components/schemas/CRUDMetadata" }, { "description": "When and by whom a resource was last modified.\n", "required": [ "at", "by" ] } ] }, "Archived": { "allOf": [ { "$ref": "#/components/schemas/CRUDMetadata" }, { "description": "When and by whom a resource was archived. This field will be absent if and only if the\nresource is not currently archived.\n", "required": [ "at", "by" ] } ] }, "PaginatedItemError": { "allOf": [ { "$ref": "#/components/schemas/ApiError" }, { "description": "An error for a single paginated list item that is omitted from the paginated list response.\n" }, { "type": "object", "properties": { "retryable": { "enum": [ "false" ] }, "details": { "type": "object", "properties": { "id": { "description": "The ID of the omitted record.", "type": "string" } } } }, "required": [ "details" ] } ], "example": { "errorCode": "generic.internal", "message": "Something went wrong.", "retryable": "false", "details": { "id": "invalidRecordId" } } }, "RandomId": { "description": "A randomly generated unique identifier.\n\nTypically has ~98 bits of entropy.\n", "example": "g56RCoZCtzv7borvp", "type": "string", "pattern": "^[a-zA-Z0-9_]+$" }, "CRUDMetadata": { "description": "When and by whom an action was performed on a resource.\n", "type": "object", "properties": { "at": { "$ref": "#/components/schemas/DateTime" }, "by": { "$ref": "#/components/schemas/ActorMetadata" } } }, "DateTime": { "description": "A date-time string as defined by\n[RFC 3339 ยง5.6](https://tools.ietf.org/html/rfc3339#section-5.6).\n", "example": "2022-11-21T19:59:10+00:00", "type": "string", "format": "date-time" }, "ActorMetadata": { "description": "Represents a user, api-token, or device.\n", "type": "object", "properties": { "type": { "$ref": "#/components/schemas/ActorType" }, "id": { "$ref": "#/components/schemas/UserId" } }, "required": [ "type", "id" ] }, "ActorType": { "description": "The type of actor performing an action.\n", "type": "string", "enum": [ "user", "client", "api-token", "app-exchange-api-token", "celosx-api-token", "automation", "instance-init", "scim", "unknown" ] }, "UserId": { "allOf": [ { "$ref": "#/components/schemas/RandomId" }, { "description": "The ID of a Tulip User.\n" }, { "$ref": "#/components/schemas/RandomId" }, { "description": "A random string which uniquely identifies a user.\n" } ] } } } } ````